using C1.Win.FlexGrid;
using System.Reflection;
using System.Runtime.InteropServices;

namespace AutomationProviderTest611
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void buttonRefill_Click(object sender, EventArgs e)
    {
      this.Refill();
    }

    private void c1FlexGrid1_DoubleClick(object sender, EventArgs e)
    {
      //This might cause the error, see "OnSelChange": the Automation event is only raised, if "ContainsFocus"
      this.Refill();
    }

    private void Refill()
    {
      try
      {
        this.c1FlexGrid1.BeginUpdate();

        this.c1FlexGrid1.Rows.Count = this.c1FlexGrid1.Rows.Fixed;
        this.c1FlexGrid1.Rows.Count = 20;
        DateTime now = DateTime.Now;
        for (int i = 0; i < 20; i++)
        {
          this.c1FlexGrid1[i, 0] = "Row " + i + " (" + now + ")";
        }

        this.c1FlexGrid1.EndUpdate();

        //Get value of field "bw" => this is the automation provider. If it is not null, the crash might occur.
        FieldInfo field = typeof(C1FlexGridBase).GetField("bw", BindingFlags.Instance | BindingFlags.NonPublic );

        object bw = field.GetValue(this.c1FlexGrid1);
        if (bw != null)
        {
          MessageBox.Show(this, "FlexGrid.bw: " + bw ?? "null");
        }
        else
        {
          MessageBox.Show(this, "FlexGrid.bw = NULL");
        }
      }
      catch (Exception ex)
      {
        MessageBox.Show(this, "ERROR: " + ex.Message + " (" + ex.GetType().FullName + ")" + Environment.NewLine + ex.StackTrace);
      }
    }
  }
}